package it.unibo.stradivarius.fragmentarticlereader;

import androidx.fragment.app.FragmentActivity;
import androidx.fragment.app.FragmentManager;
import androidx.fragment.app.FragmentTransaction;
import android.os.Bundle;
import android.util.Log;

public class MainActivity extends FragmentActivity {

    int typed;
    String BACKSTACK_ROOT_TAG = "created";

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        typed = 0;
        setContentView(R.layout.activity_main);

        FragmentManager fm = getSupportFragmentManager();

        /* Clear out the previous */
        fm.popBackStack(BACKSTACK_ROOT_TAG, FragmentManager.POP_BACK_STACK_INCLUSIVE);

        /* Add the root fragment */
        FragmentTransaction ft = fm.beginTransaction();
        TitleFragment tf = new TitleFragment();
        ft.replace(R.id.container, tf);
        ft.addToBackStack(BACKSTACK_ROOT_TAG);
        ft.commit();

        logFragments();
    }

    public void swapFragment(int id, boolean dual) {

        FragmentManager fm = getSupportFragmentManager();
        FragmentTransaction ft = fm.beginTransaction();
        DetailsFragment details = (DetailsFragment) fm.findFragmentById(R.id.details);
        if (details == null || id != typed) {
            details = new DetailsFragment();
            Bundle args = new Bundle();
            args.putInt("index", id);
            details.setArguments(args);
        }

        if (dual) {

            ft.replace(R.id.details, details);

        } else {

            ft.replace(R.id.container, details);
        }

        ft.addToBackStack("transaction " + id);
        ft.commit();

        logFragments();
    }

    public void logFragments() {
        FragmentManager fm = getSupportFragmentManager();
        for (int entry = 0; entry < fm.getBackStackEntryCount(); entry++) {
            Log.i("FRAG", "In the backstack: " + fm.getBackStackEntryAt(entry).getName());
        }
    }
}
